//
//  LetterFix.h
//  LetterFix2
//
//  Created by kuri on 10/02/01.
//  Copyright 2010-2011 kuri. All rights reserved.
//
#import <Cocoa/Cocoa.h>
#import "LFApp.h"

void swizzlingMethod(Class aClass, SEL aSelector, SEL nSelector, IMP nImplement);
int  fixTextNode(DOMText *node, DOMRange *range, BOOL isCheck, BOOL isOpen);
int  fixReflexively(DOMNode *node, DOMRange *range, BOOL isCheck, BOOL isOpen);
int  fixLetter(id self, id composeView, BOOL isCheck, BOOL isOpen);
void alert0DidEnd_returnCode_contextInfo_(id self, SEL _cmd, id alert, int returnCode, void* arg1);
void alert1DidEnd_returnCode_contextInfo_(id self, SEL _cmd, id alert, int returnCode, void* arg1);
void alert2DidEnd_returnCode_contextInfo_(id self, SEL _cmd, id alert, int returnCode, void* arg1);
BOOL _LF_IMP_isLoaded(id self, SEL _cmd);
void _LF_IMP_send_(id self, SEL _cmd, id arg1);
void _LF_IMP_saveDocument_(id self, SEL _cmd, id arg1);
void _LF_IMP_animationCompleted(id self, SEL _cmd);
BOOL checkSubject(id self);
BOOL checkSubjectOnLoad(id self);
void fixSubjectOnLoad(id self);
void fixHeader(id self);
void _LF_alertSubject(id self, SEL _cmd, id arg1);

@interface LetterFix : NSObject {
}
+ (void) initialize;
@end

typedef struct {
    unsigned int type:4;
    unsigned int composeMode:2;
    unsigned int hadChangesBeforeSave:1;
    unsigned int hasChanges:1;
    unsigned int showAllHeaders:1;
    unsigned int includeHeaders:1;
    unsigned int isUndeliverable:1;
    unsigned int isDeliveringMessage:1;
    unsigned int sendWindowsFriendlyAttachments:2;
    unsigned int contentsWasEditedByUser:1;
    unsigned int delegateRespondsToDidChange:1;
    unsigned int delegateRespondsToSenderDidChange:1;
    unsigned int delegateRespondsToDidAppendMessage:1;
    unsigned int delegateRespondsToDidSaveMessage:1;
    unsigned int delegateRespondsToDidBeginLoad:1;
    unsigned int delegateRespondsToDidEndLoad:1;
    unsigned int delegateRespondsToWillCreateMessageWithHeaders:1;
    unsigned int delegateRespondsToShouldSaveMessage:1;
    unsigned int delegateRespondsToShouldDeliverMessage:1;
    unsigned int delegateRespondsToDidCancelMessageDeliveryForMissingCertificatesForRecipients:1;
    unsigned int delegateRespondsToDidCancelMessageDeliveryForEncryptionError:1;
    unsigned int delegateRespondsToDidCancelMessageDeliveryForError:1;
    unsigned int delegateRespondsToDidCancelMessageDeliveryForAttachmentError:1;
    unsigned int signIfPossible:1;
    unsigned int encryptIfPossible:1;
    unsigned int knowsCanSign:1;
    unsigned int canSign:1;
    unsigned int shouldDownloadRemoteAttachments:1;
    unsigned int overrideRemoteAttachmentsPreference:1;
    unsigned int editorHasInitialized:1;
    unsigned int isEditing:1;
    unsigned int isSendFormatInitialized:1;
    unsigned int isAppleScriptMessage:1;
    unsigned long long encodingHint;
} _LF_flags;

// 以下の定義はwarningメッセージを消すためだけのもので，必ずしも必要ありません。
@interface LetterFix (Additions)
+ (void) registerBundle;
- (BOOL) _LF_isLoaded;
- (void) _LF_send:(id)arg1;
- (void) _LF_saveDocument:(id)arg1;
- (void) _LF_closeConfirmSheetDidEnd:(id)arg1 returnCode:(NSInteger)arg2 forSave:(void *)arg3;
- (void) _LF_animationCompleted;
- (int) messageType;
- (id) headersEditor;
- (NSObject *) backEnd;
@end

@interface NSObject (ComposeBackEnd)
- (void)setHasChanges:(BOOL)arg1;
- (unsigned int)preferredEncoding;
- (void)setPreferredEncoding:(unsigned int)arg1;
- (void)setSubject:(id)arg1;
- (NSString *)subject;
- (unsigned long long) _encodingHint;
@end

